"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Parameter_1 = require("./Parameter");
const PropertyBuilder_1 = require("../PropertyBuilder");
class BodyParameter extends Parameter_1.Parameter {
    getSchema() {
        return this.schema;
    }
    setSchema(schema) {
        this.schema = PropertyBuilder_1.toModel(schema);
    }
    copy() {
        const res = new BodyParameter();
        res.required = this.required;
        res.vendorExtensions = this.vendorExtensions;
        res.uniqueItems = this.uniqueItems;
        res.exclusiveMinimum = this.exclusiveMinimum;
        res.exclusiveMaximum = this.exclusiveMaximum;
        res.format = this.format;
        res.in = this.in;
        res.readOnly = this.readOnly;
        res.defaultValue = this.defaultValue;
        res.schema = this.schema;
        return res;
    }
}
BodyParameter.TYPE = 'body';
exports.BodyParameter = BodyParameter;
//# sourceMappingURL=BodyParameter.js.map