"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const beanUtils_1 = require("../../java/beanUtils");
const Parameter_1 = require("./Parameter");
const BodyParameter_1 = require("./BodyParameter");
const CookieParameter_1 = require("./CookieParameter");
const FormParameter_1 = require("./FormParameter");
const HeaderParameter_1 = require("./HeaderParameter");
const PathParameter_1 = require("./PathParameter");
const QueryParameter_1 = require("./QueryParameter");
const RefParameter_1 = require("./RefParameter");
beanUtils_1.beanify(Parameter_1.Parameter.prototype, [
    'name',
    'enum',
    'in',
    'description',
    'required',
    'type',
    'items',
    'collectionFormat',
    'default',
    'maximum',
    'exclusiveMaximum',
    'minimum',
    'exclusiveMinimum',
    'maxLength',
    'minLength',
    'pattern',
    'maxItems',
    'minItems',
    'uniqueItems',
    'multipleOf',
    'format',
]);
const TYPES = [
    BodyParameter_1.BodyParameter,
    CookieParameter_1.CookieParameter,
    FormParameter_1.FormParameter,
    HeaderParameter_1.HeaderParameter,
    PathParameter_1.PathParameter,
    QueryParameter_1.QueryParameter,
    RefParameter_1.RefParameter,
];
function default_1(val) {
    if (val instanceof Parameter_1.Parameter) {
        return val;
    }
    for (const ParameterType of TYPES) {
        if (ParameterType.TYPE === val.in) {
            const ret = beanUtils_1.apply(new ParameterType(val), val);
            return ret;
        }
    }
    if ('$ref' in val) {
        const rp = new RefParameter_1.RefParameter(val);
        return beanUtils_1.apply(rp, val);
    }
    throw new Error(`Could not resolve parameter type: ${val.in}`);
}
exports.default = default_1;
__export(require("./Parameter"));
__export(require("./BodyParameter"));
__export(require("./CookieParameter"));
__export(require("./FormParameter"));
__export(require("./HeaderParameter"));
__export(require("./PathParameter"));
__export(require("./QueryParameter"));
__export(require("./RefParameter"));
__export(require("./SerializableParameter"));
//# sourceMappingURL=index.js.map